#pragma once
#include "arc_interface.h"

class CArchiverUNHKI:public CArchiverDLL{
public:
	CArchiverUNHKI();
	virtual ~CArchiverUNHKI();
	virtual bool Compress(LPCTSTR,std::list<CString>&,CConfigManager&,const PARAMETER_TYPE,int,LPCTSTR,LPCTSTR,LPCTSTR,CString &)override;
	virtual bool Extract(LPCTSTR,CConfigManager&,const CConfigExtract&,bool,LPCTSTR,CString &)override;
	virtual bool ExtractSpecifiedOnly(LPCTSTR ArcFileName,CConfigManager&,LPCTSTR OutputDir,std::list<CString>&,CString &,bool bUsePath=false)override;
	virtual bool ExamineArchive(LPCTSTR,CConfigManager&,bool,bool&,bool&,CString&,CString &strErr)override;
	virtual BOOL CheckArchive(LPCTSTR)override;
	virtual bool InspectArchiveGetWriteTime(FILETIME &FileTime)override;

	virtual bool DeleteItemFromArchive(LPCTSTR ArcFileName,CConfigManager&,const std::list<CString>&,CString &strLog)override;
	virtual bool QueryDeleteItemFromArchiveSupported()const override{return true;}		//DeleteFileT|[gĂ邩ǂ
	virtual ARCRESULT TestArchive(LPCTSTR,CString &)override;	//A[JCuǂ`FbN
};

enum HKI_COMPRESS_LEVEL{
	HKI_COMPRESS_LEVEL_NORMAL,
	HKI_COMPRESS_LEVEL_NONE,
	HKI_COMPRESS_LEVEL_FAST,
	HKI_COMPRESS_LEVEL_HIGH,

	ENUM_COUNT_AND_LASTITEM(HKI_COMPRESS_LEVEL),
};

enum HKI_ENCRYPT_ALGORITHM{
	HKI_ENCRYPT_NONE,
	HKI_ENCRYPT_RIJNDAEL128,
	HKI_ENCRYPT_RIJNDAEL256,
	HKI_ENCRYPT_SINGLE_DES,
	HKI_ENCRYPT_TRIPLE_DES,
	HKI_ENCRYPT_BLOWFISH448,
	HKI_ENCRYPT_TWOFISH128,
	HKI_ENCRYPT_TWOFISH256,
	HKI_ENCRYPT_SQUARE,

	ENUM_COUNT_AND_LASTITEM(HKI_ENCRYPT_ALGORITHM),
};
