#include "stdafx.h"
#include "../ArchiverCode/arc_interface.h"
#include "ConfigManager.h"
#include "ConfigGeneral.h"

void CConfigGeneral::loadOutput(CONFIG_SECTION &Config)
{
	// o͐ނɑ΂x
	WarnNetwork=Config.Data[_T("WarnNetwork")].GetNParam(FALSE);
	WarnRemovable=Config.Data[_T("WarnRemovable")].GetNParam(FALSE);

	// o͐悪Ȃꍇ̐ݒ
	OnDirNotFound=(LOSTDIR)Config.Data[_T("OnDirNotFound")].GetNParam(0,LOSTDIR_LAST_ITEM,LOSTDIR_ERROR);
}

void CConfigGeneral::storeOutput(CONFIG_SECTION &Config)const
{
	// o͐ނɑ΂x
	Config.Data[_T("WarnNetwork")]=WarnNetwork;
	Config.Data[_T("WarnRemovable")]=WarnRemovable;

	// o͐悪Ȃꍇ̐ݒ
	Config.Data[_T("OnDirNotFound")]=OnDirNotFound;
}

void CConfigGeneral::loadLogView(CONFIG_SECTION &Config)
{
	LogViewEvent=(LOGVIEW)Config.Data[_T("LogViewEvent")].GetNParam(0,LOGVIEW_LAST_ITEM,LOGVIEW_ON_ERROR);
}

void CConfigGeneral::storeLogView(CONFIG_SECTION &Config)const
{
	Config.Data[_T("LogViewEvent")]=LogViewEvent;
}

void CConfigGeneral::loadFiler(CONFIG_SECTION &Config)
{
	Filer.UseFiler=Config.Data[_T("UseFiler")].GetNParam(FALSE);

	Filer.FilerPath=Config.Data[_T("FilerPath")];
	Filer.Param=Config.Data[_T("Param")];
}

void CConfigGeneral::storeFiler(CONFIG_SECTION &Config)const
{
	Config.Data[_T("UseFiler")]=Filer.UseFiler;

	Config.Data[_T("FilerPath")]=Filer.FilerPath;
	Config.Data[_T("Param")]=Filer.Param;
}

void CConfigGeneral::loadGeneral(CONFIG_SECTION &Config)
{
	NotifyShellAfterProcess=Config.Data[_T("NotifyShell")];
}

void CConfigGeneral::storeGeneral(CONFIG_SECTION &Config)const
{
	Config.Data[_T("NotifyShell")]=NotifyShellAfterProcess;
}

void CConfigGeneral::load(CConfigManager &ConfMan)
{
	loadOutput(ConfMan.GetSection(_T("Output")));
	loadLogView(ConfMan.GetSection(_T("LogView")));
	loadFiler(ConfMan.GetSection(_T("Filer")));
	loadGeneral(ConfMan.GetSection(_T("General")));
}

void CConfigGeneral::store(CConfigManager &ConfMan)const
{
	storeOutput(ConfMan.GetSection(_T("Output")));
	storeLogView(ConfMan.GetSection(_T("LogView")));
	storeFiler(ConfMan.GetSection(_T("Filer")));
	storeGeneral(ConfMan.GetSection(_T("General")));
}
