#include "stdafx.h"
#include "Dlg_B2E.h"
#include "../../ArchiverManager.h"
#include "../../Dialogs/LFFolderDialog.h"

//=================
// B2Eݒ
//=================
LRESULT CConfigDlgB2E::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	// bZ[W[vɃbZ[WtB^ƃAChnhǉ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);

	//---------------------------
	// B2E.DLLgǂ
	//---------------------------
	Check_EnableB2E=GetDlgItem(IDC_CHECK_ENABLE_B2E);
	Check_EnableB2E.SetCheck(m_Config.EnableDLL);

	//DDXAbvf[g
	DoDataExchange(FALSE);

	//L/
	::EnableWindow(GetDlgItem(IDC_CHECK_PRIORITIZE_B2E),Check_EnableB2E.GetCheck());
	::EnableWindow(GetDlgItem(IDC_EDIT_B2E_PRIORITY_EXTENSION),Check_EnableB2E.GetCheck());
	return TRUE;
}

LRESULT CConfigDlgB2E::OnApply()
{
//===============================
// ݒConfigManagerɏ߂
//===============================
	//---------------------------
	// B2E.DLLgǂ
	//---------------------------
	m_Config.EnableDLL=Check_EnableB2E.GetCheck();

	//---------------
	// DDXf[^XV
	//---------------
	if(!DoDataExchange(TRUE)){
		return FALSE;
	}

	return TRUE;
}


LRESULT CConfigDlgB2E::OnBrowse(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		//DDX擾
		DoDataExchange(TRUE);
		CLFFolderDialog dlg(m_hWnd,NULL,BIF_RETURNONLYFSDIRS|BIF_NEWDIALOGSTYLE);
		dlg.SetInitialFolder(m_Config.ScriptDirectory);
		if(IDOK==dlg.DoModal()){
			m_Config.ScriptDirectory=dlg.GetFolderPath();
		}
		//DDXAbvf[g
		DoDataExchange(FALSE);
	}
	return 0;
}

LRESULT CConfigDlgB2E::OnCheckEnable(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		//L/
		::EnableWindow(GetDlgItem(IDC_CHECK_PRIORITIZE_B2E),Check_EnableB2E.GetCheck());
		::EnableWindow(GetDlgItem(IDC_EDIT_B2E_PRIORITY_EXTENSION),Check_EnableB2E.GetCheck());
	}
	return 0;
}


//B2Ekj[LbV̐ƍ폜s
LRESULT CConfigDlgB2E::OnMenuCache(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED!=wNotifyCode){
		return 0;
	}
	bool bDummy;	//_~[
	CPath strPath;	//t@CpX
	//j[LbVt@C擾
	UtilGetDefaultFilePath(strPath,PROGRAMDIR_NAME,_T("B2EMenu.dat"),bDummy);
	if(IDC_BUTTON_B2E_MENUCACHE_GENERATE==wID){
		//j[LbV
		//̃LbV͍폜
		if(strPath.FileExists()){
			::DeleteFile(strPath);
		}

		//---------------
		// B2Ȅ擾
		//---------------
		//B2Enh
		CArchiverB2E &ArcB2E=CArchiverDLLManager::GetInstance().GetB2EHandler();
		if(!ArcB2E.IsOK()){
			CString msg;
			msg.Format(IDS_ERROR_DLL_LOAD,ArcB2E.GetName());
			ErrorMessage(msg);
			return 0;
		}

		//B2E擾
		std::vector<B2ESCRIPTINFO> ScriptInfoArray;
		if(!ArcB2E.EnumCompressB2EScript(ScriptInfoArray))ScriptInfoArray.clear();

#if !defined(_UNICODE)&&!defined(UNICODE)
 #error("UNICODEł̂ݎ")
#endif
		//gB2E
		if(!ScriptInfoArray.empty()){
			HANDLE hFile=CreateFile(strPath,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
			if(INVALID_HANDLE_VALUE==hFile){
				CString msg;
				msg.Format(IDS_ERROR_ACCESS_OUTPUT_FILE,strPath);
				ErrorMessage(msg);
				return false;
			}

			//---`
			for(UINT uFmt=0;uFmt<ScriptInfoArray.size();uFmt++){
				CString strFormatInfo;	//`̏([`]\t[\bh])
				strFormatInfo=CA2T(ScriptInfoArray[uFmt].szFormat);
				//---\bh
				if(ScriptInfoArray[uFmt].MethodArray.empty()){
					strFormatInfo+=_T("\tDefault");
				}
				else{
					for(UINT uMthd=0;uMthd<ScriptInfoArray[uFmt].MethodArray.size();uMthd++){
						strFormatInfo+=_T("\t");
						strFormatInfo+=CA2T(ScriptInfoArray[uFmt].MethodArray[uMthd]);
					}
				}
				strFormatInfo+=_T("\r\n");
				//t@Cɏo
				DWORD dwWritten=0;
				WriteFile(hFile,(LPCBYTE)(LPCTSTR)strFormatInfo,_tcslen(strFormatInfo)*sizeof(TCHAR),&dwWritten,NULL);
			}
			CloseHandle(hFile);
		}
	}else{
		//j[LbV폜
		if(strPath.FileExists()){
			::DeleteFile(strPath);
		}
	}
	return 0;
}
