#pragma once
#include "Dlg_Base.h"
#include "../ConfigManager.h"
#include "../../resource.h"
#include "../../ArchiverCode/ArchiverUNLHA.h"
#include "../ConfigUNLHA.h"

//====================================
// LZH̐ݒ荀
//====================================
class CConfigDlgLZH : public CDialogImpl<CConfigDlgLZH>,public CMessageFilter,public IConfigDlgBase
{
protected:
	CConfigLZH	m_Config;

	CButton	Radio_CompressType[LZH_COMPRESS_TYPE_ITEM_COUNT];
	CButton	Check_ConfigSFX;
	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_CONFIG_LZH };

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigDlgLZH)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}

	void LoadConfig(CConfigManager& Config){
		m_Config.load(Config);
	}
	void StoreConfig(CConfigManager& Config){
		m_Config.store(Config);
	}
};

