#pragma once

#include "ArcFileContent.h"
#include "../Dialogs/WaitDialog.h"

struct AnimationUpdater:public IArchiveContentUpdateHandler{
	virtual ~AnimationUpdater(){}
	CWaitDialog *lpDialog;
	void onUpdated(ARCHIVE_ENTRY_INFO &rInfo){
		if(lpDialog){
			lpDialog->AnimationCall();
			lpDialog->SetMessageString(rInfo.strFullPath);
		}
	}
	bool isAborted(){
		if(lpDialog){
			return lpDialog->IsAborted();
		}else return false;
	}
};

