#pragma once

//---o^ꂽ|C^fXgNgɎIdeleteg^X}[g|C^
template <typename T>
class CSmartPtrCollection{
private:
	std::set<T*> m_Ptr;
public:
	CSmartPtrCollection(){}
	virtual ~CSmartPtrCollection(){DeleteAll();}
	void Add(T* lpT){	//Ǘɓ
		ASSERT(lpT);
		if(lpT){
			m_Ptr.insert(lpT);
		}
	}
	void Remove(T* lpT){	//|C^ǗO
		m_Ptr.erase(lpT);
	}
	void RemoveAll(){	//S|C^ǗO
		m_Ptr.clear();
	}
	void Delete(T* lpT){	//|C^deleteĊǗO
		ASSERT(lpT);
		if(lpT){
			m_Ptr.erase(lpT);
			delete lpT;
		}
	}
	void DeleteAll(){	//S|C^deleteĊǗO
		std::set<T*>::iterator ite=m_Ptr.begin();
		const std::set<T*>::iterator end=m_Ptr.end();
		for(;ite!=end;++ite){
			delete *ite;
		}
		m_Ptr.clear();
	}
};


template <typename T>
class CSmartPtrCollectionArray
{
protected:
	CSmartPtrCollection<T> m_Ptr;
	std::vector<T*> m_Array;
public:
	CSmartPtrCollectionArray(){}
	virtual ~CSmartPtrCollectionArray(){}
	void push_back(T* lpT){	//Ǘɓ
		m_Ptr.Add(lpT);
		m_Array.push_back(lpT);
	}

	(T*)& operator[](size_t idx){return m_Array[idx];}
	size_t size()const{return m_Array.size();}
};
