#pragma once

//A[JCovWFNgdl̃t@C
#define FA_RDONLY		0x01			// ݕی쑮
#define FA_HIDDEN		0x02			// B
#define FA_SYSTEM		0x04			// VXe
#define FA_LABEL		0x08			// {[Ex
#define FA_DIREC		0x10			// fBNg
#define FA_ARCH			0x20			// A[JCu
#define FA_UNKNOWN		0x40			// sȑ(LhaForge̓Ǝg)


//tH_̎ʕ(gq)
const LPCTSTR FOLDER_EXTENSION_STRING=_T("***");

//A[JCũt@C/tH_̃Ggێ
struct ARCHIVE_ENTRY_INFO{	//t@CACeێ
	virtual ~ARCHIVE_ENTRY_INFO(){}

	CString			strFullPath;	//i[ꂽƂ̖O
	CString			strExt;			//t@Cgq
	int				nAttribute;		//;tH_ǂȂǂ̏
	CString			strMethod;		//k\bh
	WORD			wRatio;			//k
	DWORD			dwCRC;			//CRC
	LARGE_INTEGER	llOriginalSize;		//i[t@C̈kÕTCY(fBNgȂAɓĂt@CTCY̍v)
	LARGE_INTEGER	llCompressedSize;	//i[t@C̈k̃TCY(fBNgȂAɓĂt@CTCY̍v)
	FILETIME		cFileTime;		//i[t@CŏIXV

	bool bSafe;
};

struct ARCHIVE_ENTRY_INFO_TREE:public ARCHIVE_ENTRY_INFO{
	virtual ~ARCHIVE_ENTRY_INFO_TREE(){}
	typedef std::hash_map<stdString,ARCHIVE_ENTRY_INFO_TREE*> DICT;
	std::vector<ARCHIVE_ENTRY_INFO_TREE*> childrenArray;
	DICT					childrenDict;
	ARCHIVE_ENTRY_INFO_TREE	*lpParent;
	CString					strTitle;
	bool					bDir;			//fBNgǂ

	size_t GetNumChildren()const{return childrenArray.size();}
	ARCHIVE_ENTRY_INFO_TREE* GetChild(size_t idx)const;
	ARCHIVE_ENTRY_INFO_TREE* GetChild(LPCTSTR lpName)const;
	void Clear(){
		lpParent=NULL;
		childrenArray.clear();
		childrenDict.clear();

		nAttribute=-1;
		wRatio=0xFFFF;
		dwCRC=-1;
		llOriginalSize.HighPart=-1;
		llOriginalSize.LowPart=-1;
		llCompressedSize.HighPart=-1;
		llCompressedSize.LowPart=-1;
		cFileTime.dwLowDateTime=-1;
		cFileTime.dwHighDateTime=-1;
		bSafe=true;
	}

	//ȉ̃t@C
	void EnumFiles(std::list<CString> &rFileList)const;
};

//[g݂Ď܂ł̃pX擾
void ArcEntryInfoTree_GetNodePathRelative(const ARCHIVE_ENTRY_INFO_TREE* lpDir,const ARCHIVE_ENTRY_INFO_TREE* lpBase,CString &strPath);
