#include "stdafx.h"
#include "../ArchiverCode/ArchiverBGA.h"
#include "ConfigManager.h"
#include "ConfigBGA.h"

void CConfigBGA::load(CONFIG_SECTION &Config)
{
	//kx
	BZALevel=Config.Data[_T("BZALevel")].GetNParam(BZA_COMPRESS_LEVEL_LOWEST,BZA_COMPRESS_LEVEL_HIGHEST,9);
	GZALevel=Config.Data[_T("GZALevel")].GetNParam(GZA_COMPRESS_LEVEL_LOWEST,GZA_COMPRESS_LEVEL_HIGHEST,9);
}

void CConfigBGA::store(CONFIG_SECTION &Config)const
{
	Config.Data[_T("BZALevel")]=BZALevel;
	Config.Data[_T("GZALevel")]=GZALevel;
}

void CConfigBGA::load(CConfigManager &ConfMan)
{
	load(ConfMan.GetSection(_T("BGA")));
}

void CConfigBGA::store(CConfigManager &ConfMan)const
{
	store(ConfMan.GetSection(_T("BGA")));
}
