#include "stdafx.h"
#include "../ArchiverCode/ArchiverCAB.h"
#include "ConfigManager.h"
#include "ConfigCAB.h"

void CConfigCAB::load(CONFIG_SECTION &Config)
{
	//k`
	CompressType=(CAB_COMPRESS_TYPE)Config.Data[_T("CompressType")].GetNParam(0,CAB_COMPRESS_TYPE_LAST_ITEM,0);
	//LZXk̃x
	LZX_Level=Config.Data[_T("LZXLevel")].GetNParam(CAB_LZX_LOWEST,CAB_LZX_HIGHEST,CAB_LZX_LOWEST);
}

void CConfigCAB::store(CONFIG_SECTION &Config)const
{
	//k`
	Config.Data[_T("CompressType")]=CompressType;
	//LZXk̃x
	Config.Data[_T("LZXLevel")]=LZX_Level;
}

void CConfigCAB::load(CConfigManager &ConfMan)
{
	load(ConfMan.GetSection(_T("CAB")));
}

void CConfigCAB::store(CConfigManager &ConfMan)const
{
	store(ConfMan.GetSection(_T("CAB")));
}
