#include "stdafx.h"
#include "../ArchiverCode/arc_interface.h"
#include "ConfigManager.h"
#include "ConfigCompress.h"
#include "../Utilities/FileOperation.h"

void CConfigCompress::load(CONFIG_SECTION &Config)
{
	//o͐̎
	OutputDirType=(OUTPUT_TO)Config.Data[_T("OutputDirType")].GetNParam(0,OUTPUT_TO_LAST_ITEM,OUTPUT_TO_DESKTOP);
	//o͐̃pX
	CString Buffer=Config.Data[_T("OutputDir")];
	if(!Buffer.IsEmpty()){
		UtilGetCompletePathName(OutputDir,Buffer);
	}else{
		OutputDir=_T("");
	}
	//ktH_Jǂ
	OpenDir=Config.Data[_T("OpenFolder")].GetNParam(TRUE);

	//o̓t@Cw肷邩ǂ
	SpecifyOutputFilename=Config.Data[_T("SpecifyName")].GetNParam(FALSE);

	//Ɉkt@C𐧌
	LimitCompressFileCount=Config.Data[_T("LimitCompressFileCount")].GetNParam(FALSE);

	//Ɉkt@C̏
	MaxCompressFileCount=max(1,(int)Config.Data[_T("MaxCompressFileCount")]);

	//ftHgkp[^gpȂtrue
	UseDefaultParameter=Config.Data[_T("UseDefaultParameter")].GetNParam(FALSE);

	//ftHgkp[^(`w)
	DefaultType=(PARAMETER_TYPE)Config.Data[_T("DefaultType")].GetNParam(0,PARAMETER_LAST_ITEM,PARAMETER_UNDEFINED);

	//ftHgkp[^̃IvV
	DefaultOptions=Config.Data[_T("DefaultOptions")].GetNParam(0);

	//B2Ek̏
	DefaultB2EFormat=Config.Data[_T("DefaultB2EFormat")];
	DefaultB2EMethod=Config.Data[_T("DefaultB2EMethod")];

	//Ɉkłt@C폜
	DeleteAfterCompress=Config.Data[_T("DeleteAfterCompress")].GetNParam(FALSE);
	//kt@CݔɈړ
	MoveToRecycleBin=Config.Data[_T("MoveToRecycleBin")].GetNParam(TRUE);
	//mFɍ폜/ݔɈړ
	DeleteNoConfirm=Config.Data[_T("DeleteNoConfirm")].GetNParam(FALSE);
	//폈mFłȂ`ł폜
	ForceDelete=Config.Data[_T("ForceDelete")].GetNParam(FALSE);

	//utH_艺̃t@Ckv
	IgnoreTopDirectory=Config.Data[_T("IgnoreTopDirectory")].GetNParam(FALSE);
}

void CConfigCompress::store(CONFIG_SECTION &Config)const
{
	//o͐̎
	Config.Data[_T("OutputDirType")]=OutputDirType;
	//o͐̃pX
	Config.Data[_T("OutputDir")]=OutputDir;
	//ktH_Jǂ
	Config.Data[_T("OpenFolder")]=OpenDir;

	//o̓t@Cw肷邩ǂ
	Config.Data[_T("SpecifyName")]=SpecifyOutputFilename;

	//Ɉkt@C𐧌
	Config.Data[_T("LimitCompressFileCount")]=LimitCompressFileCount;

	//Ɉkt@C̏
	Config.Data[_T("MaxCompressFileCount")]=MaxCompressFileCount;

	//ftHgkp[^gpȂtrue
	Config.Data[_T("UseDefaultParameter")]=UseDefaultParameter;

	//ftHgkp[^(`w)
	Config.Data[_T("DefaultType")]=DefaultType;

	//ftHgkp[^̃IvV
	Config.Data[_T("DefaultOptions")]=DefaultOptions;

	//B2Ek̏
	Config.Data[_T("DefaultB2EFormat")]=DefaultB2EFormat;
	Config.Data[_T("DefaultB2EMethod")]=DefaultB2EMethod;

	//Ɉkłt@C폜
	Config.Data[_T("DeleteAfterCompress")]=DeleteAfterCompress;
	//kt@CݔɈړ
	Config.Data[_T("MoveToRecycleBin")]=MoveToRecycleBin;
	//mFɍ폜/ݔɈړ
	Config.Data[_T("DeleteNoConfirm")]=DeleteNoConfirm;
	//폈mFłȂ`ł폜
	Config.Data[_T("ForceDelete")]=ForceDelete;

	//utH_艺̃t@Ckv
	Config.Data[_T("IgnoreTopDirectory")]=IgnoreTopDirectory;
}

void CConfigCompress::load(CConfigManager &ConfMan)
{
	load(ConfMan.GetSection(_T("Compress")));
}

void CConfigCompress::store(CConfigManager &ConfMan)const
{
	store(ConfMan.GetSection(_T("Compress")));
}
