#include "stdafx.h"
#include "../ArchiverCode/Archiver7ZIP.h"
#include "ConfigManager.h"
#include "ConfigZIP.h"

// ZIPkݒ
void CConfigZIP::load(CONFIG_SECTION &Config)
{
	//k`
	CompressType=(ZIP_COMPRESS_TYPE)Config.Data[_T("CompressType")].GetNParam(0,ZIP_COMPRESS_TYPE_LAST_ITEM,0);
	//kx
	CompressLevel=(ZIP_COMPRESS_LEVEL)Config.Data[_T("CompressLevel")].GetNParam(0,ZIP_COMPRESS_LEVEL_LAST_ITEM,0);
	//㋉ݒ
	//D悷郁̃oCgw肷邩ǂ
	SpecifyDeflateMemorySize=Config.Data[_T("SpecifyDeflateMemorySize")].GetNParam(FALSE);
	//D悷郁̃oCg
	DeflateMemorySize=Config.Data[_T("DeflateMemorySize")].GetNParam(ZIP_DEFLATE_MEMORY_SIZE_LOWEST,ZIP_DEFLATE_MEMORY_SIZE_HIGHEST,32);
	//GR[_̃pXw肷邩ǂ
	SpecifyDeflatePassNumber=Config.Data[_T("SpecifyDeflatePassNumber")].GetNParam(FALSE);
	//GR[_̃pX
	DeflatePassNumber=Config.Data[_T("DeflatePassNumber")].GetNParam(ZIP_DEFLATE_PASS_NUMBER_LOWEST,ZIP_DEFLATE_PASS_NUMBER_HIGHEST,1);
}

void CConfigZIP::store(CONFIG_SECTION &Config)const
{
	//k`
	Config.Data[_T("CompressType")]=CompressType;
	//kx
	Config.Data[_T("CompressLevel")]=CompressLevel;
	//㋉ݒ
	//D悷郁̃oCgw肷邩ǂ
	Config.Data[_T("SpecifyDeflateMemorySize")]=SpecifyDeflateMemorySize;
	//D悷郁̃oCg
	Config.Data[_T("DeflateMemorySize")]=DeflateMemorySize;
	//GR[_̃pXw肷邩ǂ
	Config.Data[_T("SpecifyDeflatePassNumber")]=SpecifyDeflatePassNumber;
	//GR[_̃pX
	Config.Data[_T("DeflatePassNumber")]=DeflatePassNumber;


	// pX[h֘A;݂̓pX[hpR[ĥ
	//w肳ꂽpX[hIɍ폜
	Config.Data.erase(_T("UseFixedPassword"));
	Config.Data.erase(_T("PasswordLength"));
	Config.Data.erase(_T("Password"));
}

void CConfigZIP::load(CConfigManager &ConfMan)
{
	load(ConfMan.GetSection(_T("ZIP")));
}

void CConfigZIP::store(CConfigManager &ConfMan)const
{
	store(ConfMan.GetSection(_T("ZIP")));
}
