#pragma once
//#include "DataObject.h"
//Original code from http://hp.vector.co.jp/authors/VA016117/
//Modified by Claybird http://claybird.sakura.ne.jp/

struct ARCHIVE_ENTRY_INFO_TREE;
class CFileListModel;
class CDropSource : public IDropSource
{
protected:
	LONG _RefCount;
	CFileListModel& _rModel;
	std::list<ARCHIVE_ENTRY_INFO_TREE*> _items;
	CString _strOutputDir;
	ARCHIVE_ENTRY_INFO_TREE* _lpBase;
	DWORD _dwEffect;
public:
	CDropSource(CFileListModel &rModel,const std::list<ARCHIVE_ENTRY_INFO_TREE*> &items,LPCTSTR lpOutputDir,ARCHIVE_ENTRY_INFO_TREE* lpBase)
		:_RefCount(1),_rModel(rModel),_items(items),_strOutputDir(lpOutputDir),_lpBase(lpBase),_dwEffect(0),_bRet(true)
	{}
	virtual ~CDropSource(){};

	virtual HRESULT __stdcall QueryInterface(const IID& iid, void** ppv);
	virtual ULONG __stdcall AddRef(void);
	virtual ULONG __stdcall Release(void);

	virtual HRESULT __stdcall QueryContinueDrag(BOOL fEscapePressed, DWORD grfKeyState);
	virtual HRESULT __stdcall GiveFeedback(DWORD dwEffect);

public:
	CString _strLog;
	bool _bRet;
};

